using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_ForeignKeyReference
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.DataGrid dataGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(504, 192);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.201.1.0";
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(32, 240);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(504, 160);
			this.dataGrid1.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 414);
			this.Controls.Add(this.dataGrid1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//set up the main table
			DataTable dt = GetMainDataTable();
			this.gridGroupingControl1.DataSource = dt;
			this.gridGroupingControl1.ShowGroupDropArea=true;

			// set lookup
			DataTable lookUpDataTable = this.GetForeignTable();
			SetLookup(lookUpDataTable,"LookUpCol","DisplayCol","idCol");
		}


		private void SetLookup(DataTable lookUpDataTable,
			string LookUpCol,string DisplayCol,string IdCol)
		{
			//We are going to display a column named DisplayCol in the foreign
			//table where a column named LookUpCol is located in teh main table.
			//LookUpCol holds keys values that match the values in a column
			//named IdCol in the foriegn table. The steps are:
			// 1. Save the location of the maintable.LookUpCol column so it can be swapped
			//    after the foreign table reference has been set up
			// 2. Add the foreign table to the Engine's SourceList
			// 3. Create and setup a RelationKind.ForeignKeyReference relation
			// 4. Set any optional properties on the relation
			// 5. Add relation descriptor to main tabledescriptor
			// 6. Replace maintable.LookUpCol with foreigntable.DisplayCol


			//step 1. remember the location of lookupcol so it can be swapped out later
			GridTableDescriptor td = this.gridGroupingControl1.TableDescriptor;
			td.VisibleColumns.LoadDefault();
			int lookUpIndex = td.VisibleColumns.IndexOf(LookUpCol);
			string ColumnHeader=td.Columns[LookUpCol].HeaderText;
			
			//get the lookup table
			//DataTable lookUpDataTable = this.GetForeignTable();

			//			DataSet ds2 = new DataSet("LookUp");
			//			ds2.Tables.Add(lookUpDataTable);
			
			//step 2. add it to the grouping engine
			this.gridGroupingControl1.Engine.SourceListSet.Add(lookUpDataTable.TableName, lookUpDataTable.DefaultView);

			//step 3. Create and setup a RelationKind.ForeignKeyReference relation

			//set up relation descriptor that defines mapping between main table and foreign table
			GridRelationDescriptor rd = new GridRelationDescriptor();
			rd.Name = LookUpCol+"2Display"; //just some unique name
			rd.RelationKind = RelationKind.ForeignKeyReference; //foreign key look up
			rd.ChildTableName = lookUpDataTable.TableName;  // SourceListSet name for lookup

			//get foreign key for col "IdCol" in foreign table
			rd.RelationKeys.Add(LookUpCol, IdCol); //col in main table,  foreign key col

			//step 4. Set any optional properties on the relation
			// dropdown only shows DisplayCol
			rd.ChildTableDescriptor.VisibleColumns.Add(DisplayCol); //display column
			rd.ChildTableDescriptor.SortedColumns.Add(DisplayCol); //sort it for dropdown display
			rd.ChildTableDescriptor.AllowEdit = false; //no editing of foreign table
			rd.ChildTableDescriptor.AllowNew = false;  //no new items added to foreign table
			rd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;
			

			//no dropdown button in columns
			//td.TableOptions.AllowForeignKeyDropDown = false; 

			//step 5. add relation descriptor to main tabledescriptor
			td.Relations.Add(rd);
			//***** 

			//step 6. Replace maintable.LookUpCol with foreigntable.DisplayCol
			string foreignPrefix = rd.Name + "_";
			//get the hashed name of foreign col
			string foreignDisplayColInMainTable = foreignPrefix + DisplayCol; 
			td.VisibleColumns.Insert(lookUpIndex, foreignDisplayColInMainTable);
			//set its headertext to something other than default hashedname
			td.Columns[foreignDisplayColInMainTable].HeaderText = ColumnHeader;
			td.Columns[foreignDisplayColInMainTable].Appearance.AnyCell.BackColor = Color.LightGoldenrodYellow;

		}

		
		#region datatables
		int foreignKeyCount = 5;
		private DataTable GetMainDataTable()
		{
			string name = "MainTable";
			int nCols = 6;
			int nRows = 10;
			DataTable dt = new DataTable(name);
			for(int i = 0; i < nCols; i++)
			{
				if(i != 2)
					dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
				else
					dt.Columns.Add(new DataColumn("LookUpCol", typeof(int)));
			}

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if(j != 2)
						dr[j] = string.Format("row{0} col{1}", i, j);
					else
						dr[j] = r.Next(this.foreignKeyCount);;
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private DataTable GetForeignTable()
		{
			string name = "ForeignTable";
			int nCols = 6;
			int nRows = this.foreignKeyCount;
			DataTable dt = new DataTable(name);
			for(int i = 0; i < nCols; i++)
			{
				if(i == 0)
				{
					dt.Columns.Add(new DataColumn("idCol", typeof(int)));
				}
				else if(i != 2)
					dt.Columns.Add(new DataColumn(string.Format("SomeCol{0}", i)));
				else
					dt.Columns.Add(new DataColumn("DisplayCol"));
			}

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if(j == 0)
						dr[j] = i;
					else if(j != 2)
						dr[j] = string.Format("row{0} col{1}", i, j);
					else
						dr[j] =  string.Format("display{0}", i);
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}
		#endregion
	}
}
